begin def

   stack 2k
   strsegsize 64k

' Including C:\BIN\MOON\ffblk.h
' bundle definition for FINDFIRST, FINDNEXT, FEXIST functions

bundle FFBLK attr@, time%, date%, size&, name$[13] null
' Including args.h
   sub getargs
   sub quoted( quoter$ )
   sub param
   sub other
   sub store( item$ )

   dim arg_v$[ 100 ]

   common cmd$, arg_c%
' Including getini.h
   ' support items for use by ini.moo

   common inivalue$, iItemCount%, opstatus%, getini_file$

   DIM aIniBuffer$[ 1000 ]

   sub getIni( pInifile$, pIniSect$, pIniItem$, pIniDefault$ )
   sub insection( pItemno%, pMaxitems%, pItem$, pDefault$ )
   sub loadini( pInifile$ )
' Including swapper.h
   common swapped$
   sub swapper( template$, symbol$, replacement$ )
' Including addext.h
   sub addext( name$, ext$ )
   common withext$, withoutext$
' Including stopping.h
   sub stopping
   common stopping%
' Including instring.h
   sub instring( target$, pattern$ )
   common instring_%
' Including parsefil.h
' Including nopath.h
   sub nopath( spec$ )
   common withoutpath$
   common justPath$

   sub parsefil( fspec$ )
   common PF_drv$
   common PF_path$
   common PF_nameExt$
   common PF_name$
   common PF_ext$

    sub help
    sub process( filename$, searchterm$, caseness%, quietness%, bracketicness%, ltrimness%, viewness%, batchness%, fileness% )
    sub loadviewer( viewer$ )
    sub viewit( file$, lineno$ )
    common comspec$, viewerprog$, viewerargs$
    common inifile$
    common finder$

   dim filelist$[ 1000 ]
begin code

   call getargs
   if arg_c% < 3 then
      call help
      end
   endif

   comspec$ = getenv( "COMSPEC" )

   xList$ = chr( 255 )

   fspec$ = arg_v$[ 1 ]
   call parsefil( fspec$ )
   fpath$ = PF_path$
   finder$ = arg_v$[ 2 ]
   arg_c% = arg_c% - 1
   quiet% = false
   upper% = false
   bracketic% = false
   ltrimic% = false
   xlistic% = false
   viewic%  = false
   batchic% = false
   fileic% = false
   viewsec$ = ""

   for j% = 3 to arg_c%
      opt$ = arg_v$[ j% ]
      first$ = left( opt$, 1 )
      if first$ = "/" then
         second$ = mid( opt$, 2, 1 )
         second$ = ucase( second$ )
         third$ = mid( opt$, 3 )
         select case second$
            case "B"
                batchic% = true
                quiet% = true
            case "U"
                finder$ = ucase( finder$ )
                upper% = true
            case "Q"
                quiet% = true
            case "["
                bracketic% = true
            case "L"
                ltrimic% = true
            case "V"
                viewic% = true
                viewsec$ = third$
            case "X"
                xlistic% = true
                xItem$ = third$
                xItem$ = rtrim( xItem$ )
                xItem$ = ltrim( xItem$ )
                xItem$ = ucase( xItem$ )
                xList$ = xList$ + xItem$ + chr( 255 )
            case "F"
                fileic% = true
         end select
      endif
   next

   if viewic% = true then call loadviewer( viewsec$ )

   if quiet% = false then
       print "Searching "
       print fspec$
       print " for "
       print finder$
       print "\n"
   endif

   i% = 0
   b$ = findfirst( fspec$, 7 )
   while b$ <> ""
      filelist$[ i% ] = fpath$ + b$
      i% = i% + 1
      b$ = findnext
   wend
   i% = i% - 1
   for j% = 0 to i%
       b$ = filelist$[ j% ]
       if quiet% = false then
           print "Searching "
           print b$
           print "\n"
       endif
       if xlistic% = true then
         inxlist% = instr( xList$, b$ )
         if inxlist% = 0 then
            call process( b$, finder$, upper%, quiet%, bracketic%, ltrimic%, viewic%, batchic%, fileic% )
         else
            if quiet% = false then
               print "Ignoring " + b$ + "\n"
            endif
         endif
       else
         call process( b$, finder$, upper%, quiet%, bracketic%, ltrimic%, viewic%, batchic%, fileic% )
       endif
       b$ = findnext
   next
   end

sub process( filename$, searchterm$, caseness%, quietness%, bracketicness%, ltrimness%, viewness%, batchness%, fileness% )
    forever% = true
    n% = 0
    h% = fopen( filename$, readonly )
    viewed% = false
    while forever%

       if inkey() = 27 then
         call stopping
         if stopping% = true then
            end
         endif
       endif

        finput( h%, arec$ )
        if feof( h% ) = true then
            exit while
        endif
        n% = n% + 1
        if caseness% = true then
            arectest$ = ucase( arec$ )
        else
            arectest$ = arec$
        endif

        call instring( arectest$, searchterm$ )
        npos% = instring_%

        if npos% > 0 then
            if fileness% = true then
               print filename$ + "\n"
               exit while
            endif
            nstr$ = str( n% )
            nstr$ = ltrim( nstr$ )
            if viewness% then
               viewed% = true
               fclose( h% )
               call viewit( filename$, nstr$ )
               exit while
            endif
            nstr$ = space(5) + nstr$
            nstr$ = right( nstr$, 5 )
            if batchness% = false then
                if quietness% = true then
                    fillfile$ = filename$ + space( 12 )
                    fillfile$ = left( fillfile$, 12 )
                    print fillfile$ + space( 1 )
                endif
            endif
            if batchness% = false then
                if bracketicness% = true then
                    print "[" + nstr$ + "]"
                else
                    print nstr$ + ":"
                endif
                if ltrimness% = true then
                   print ltrim( arec$ )
                else
                   print arec$
                endif
            else
                print ltrim( arec$ )
            endif
            print "\n"

        endif
    wend
    if viewness% = false then
      fclose( h% )
    else
        if viewed% = false then
            fclose( h% )
        endif
    endif
end sub

sub help
   print "Usage:\n    SEARCH <filespec> <string> [/Q][/U][/C][/L][/X<filespec>][/V<viewer>][/F]\n"
   print "\n<string> may be quoted using ' or " + chr(34) + ".\n"
   print "\n/Q - quiet."
   print "\n/U - caseless."
   print "\n/[ - line numbers as [#] not #:"
   print "\n/L - ltrim found lines."
   print "\n/X - exclude the file (can be repeated )."
   print "\n/V - view the file. Viewers defined in SEARCH.INI."
   print "\n     If no SEARCH.INI, defaults to EDIT.COM."
   print "\n/B - batch. Output has no line numbers or filenames. Lines are ltrimmed."
   print "\n     /B asserts /Q."
   print "\n/F - filename only. No line numbers."
   print "\n     /F will cause /[, /B and /V to be ignored."
   print "\n"
end sub

sub loadviewer( viewer$ )
   inifile$ = arg_v$[ 0 ]
   call addext( inifile$, ".INI" )
   inifile$ = withext$
   viewer$ = ltrim( viewer$ )
   if len( viewer$ ) = 0 then
        viewer$ = "DEFAULT"
   else
        viewer$ = ucase( viewer$ )
   endif
   call getini( inifile$, viewer$, "Prog", "C:/DOS/EDIT.COM" )
   viewerprog$ = inivalue$
   if fexist( viewerprog$, 7 ) = false then
      print "Could not find " + viewerprog$ + "\n"
      end
   endif
   call getini( inifile$, viewer$, "Args", "$f" )
   viewerargs$ = inivalue$
end sub

sub viewit( file$, lineno$ )
   call parsefil( file$ )
   call swapper( viewerargs$, "$fne", PF_nameExt$ )
   viewcmd$ = swapped$
   call swapper( viewcmd$, "$fd", PF_drv$ )
   viewcmd$ = swapped$
   call swapper( viewcmd$, "$fp", PF_path$ )
   viewcmd$ = swapped$
   call swapper( viewcmd$, "$fn", PF_name$ )
   viewcmd$ = swapped$
   call swapper( viewcmd$, "$fe", PF_ext$ )
   viewcmd$ = swapped$
   call swapper( viewcmd$, "$f", file$ )
   viewcmd$ = swapped$
   call swapper( viewcmd$, "$n", lineno$ )
   viewcmd$ = swapped$
   call swapper( viewcmd$, "$s", finder$ )
   viewcmd$ = swapped$
#ifdef DEBUG
   print viewerprog$ + " " + viewcmd$ + "\n"
#endif
   ret% = exec( viewerprog$, viewcmd$ )
   a% = ret%
end sub

' Including args.sub
sub getargs
   dquote$ = chr(34)
   squote$ = "'"

   me$ = mypath()
   me$ = ftruename( me$ )
   arg_v$[ 0 ] = me$

   arg_c% = 1

   'get command line
   cmd$ = cmdline

   'repeat until empty command line
   forever% = true
   while forever%
      cmd$ = ltrim( cmd$ )
      if cmd$ = "" then
         exit while
      endif

      'get first char of command line
      first$ = left( cmd$, 1 )

      select case first$
         case squote$
            call quoted( squote$ )
         case dquote$
            call quoted( dquote$ )
         case "/"
            call param
         case "-"
            call param
         case else
            call other
      end select
   wend
end sub
sub quoted( quoter$ )
   item$ = mid( cmd$, 2 )
   there% = sinstr( item$, quoter$ )
   if there% > 0 then
      there% = there% - 1
      item$ = left( item$, there% ) 'mid( item$, 1, there% )
      there% = there% + 3
      '... and remove this first item from the command line
      cmd$ = mid( cmd$, there% )
   else
      cmd$ = ""
   endif
   call store( item$ )
end sub

sub param
   sep% = 32
   there% = cinstr( cmd$, sep% )
   if there% > 0 then
      there% = there% - 1
      item$ = left( cmd$, there% )
      '... and remove this first item from the command line
      there% = there% + 2
      cmd$ = mid( cmd$, there% )
   else
      item$ = cmd$
      cmd$ = ""
   endif
   call store( item$ )
end sub

sub other
   'otherwise next item in array is first item
   there% = cinstr( cmd$, 32 )
   if there% > 0 then
      there% = there% - 1
      item$ = left( cmd$, there% )
      '... and remove this first item from the command line
      there% = there% + 2
      cmd$ = mid( cmd$, there% )
   else
      item$ = cmd$
      cmd$ = ""
   endif
   call store( item$ )
end sub

sub store( item$ )
   arg_v$[ arg_c% ] = item$
   arg_c% = arg_c% + 1
end sub
' Including getini.sub
sub getIni( pInifile$, pIniSect$, pIniItem$, pIniDefault$ )
#ifdef GETINI
   fprint( 4, pInifile$ + " " + pIniSect$ + " " + pIniItem$ + " " + pIniDefault$ + "\n" )
#endif

   iniValue$ = pIniDefault$
   Section$ = "[" + pIniSect$ + "]"

   iniValue$ = pIniDefault$
#ifdef GETINI
   fprint( 4, getini_file$ + " " + pInifile$ + "\n" )
#endif
   if getini_file$ <> pInifile$ then
      call LoadIni( pInifile$ )
      getini_file$ = pInifile$
   endif
   IF iItemCount% > 0 then
      FOR Item% = 0 TO iItemCount%
         inputline$ = aIniBuffer$[ Item% ]
         inputline$ = ltrim( inputline$ )
         SectLen% = LEN( Section$ )
         Temp$ = LEFT( inputline$, SectLen% )
         IF Temp$ = Section$ then
            call InSection( Item%, iItemCount%, pIniItem$, pIniDefault$ )
            EXIT for
         ENDIF
      NEXT
   ENDIF
#ifdef GETINI
   fprint( 4, " " + iniValue$ + "\n" )
#endif
end sub

sub insection( pItemno%, pMaxitems%, pItem$, pDefault$ )
   Item$ = pItem$ + "="
   iniValue$ = pDefault$

   n% = pItemno% + 1
   FOR Item% = n% TO pMaxitems%
      inputline$ = aIniBuffer$[ Item% ]
      inputline$ = rTRIM( inputline$ )
      inputline$ = ltrim( inputline$ )
      LeftChar$ = LEFT( inputline$, 1 )
      IF LeftChar$ = "[" then
         EXIT for
      endif
      ItemLen% = Len( Item$ )
      Temp$ = LEFT( inputline$, ItemLen% )
      IF Temp$ = Item$ then
         ItemLen% = ItemLen% + 1
         iniValue$ = mid( inputline$, ItemLen% )
         EXIT for
      ENDIF
   NEXT
end sub

sub loadini( pInifile$ )
    iItemCount% = 0
    if fexist( pIniFile$, 7 ) = false then
        exit sub
    endif
    iniHandle% = fopen( pInifile$, readonly )
    forever% = true
    while forever%
        inputline$ = space(127)
        finput(iniHandle%, inputline$)
        if feof( iniHandle% ) = true then
            exit while
        endif
        inputline$ = rTRIM( inputline$ )
        aIniBuffer$[ iItemCount% ] = inputline$
        iItemCount% = iItemCount% + 1
    wend
    fclose( iniHandle% )
end sub

' Including swapper.sub
sub swapper( template$, symbol$, replacement$ )
    forever% = true
    swapped$ = template$
    if len( symbol$ ) < 1
       exit sub
    endif
    while forever%
        swapfind% = instr( swapped$, symbol$ )
        if swapfind% > 0 then
            leftswap% = swapfind% - 1
            swapleft$ = left( swapped$, leftswap% )
            rightswap% = swapfind% + len( symbol$ )
            swapright$ = mid( swapped$, rightswap% )
            swapped$ = swapleft$ + replacement$ + swapright$
        else
            exit while
        endif
    wend
end sub
' Including addext.sub
sub addext( name$, ext$ )
   truename$ = ftruename( name$ )
   extdot% = cinstr( truename$, 46 )
   if extdot% > 0 then
      extdot% = extdot% - 1
      withoutext$ = left( truename$, extdot% )
   else
      withoutext$ = truename$
   endif
   withext$ = withoutext$ + ext$
end sub
' Including stopping.sub
sub stopping

   print "\nStop processing (Y/N)? "
   flag% = true
   while flag%
      stop% = inkey()
      if stop% > 0 then
         stopper$ = chr( stop% )
         stopper$ = ucase( stopper$ )
         if stopper$ = "Y" then
            exit while
         endif
         if stopper$ = "N" then
            exit while
         endif
      endif
   wend
   print stopper$ + "\n"
   if stopper$ = "Y" then
      stopping% = true
   else
      stopping% = false
   endif

end sub

' Including instring.sub
sub instring( target$, pattern$ )
    instring_% = 0
    if target$ = "" then exit sub
    if pattern$ = "" then exit sub
    instring_% = instr( target$, pattern$ )
end sub
' Including parsefil.sub
' Including nopath.sub
sub nopath( spec$ )
   i% = len( spec$ )
   found% = false
   forever% = true
   while forever%
#ifdef NOPATH
print "i%=" + i% + "\n"
#endif
      c$ = mid( spec$, i%, 1 )
      if c$ = "\\" then
         found% = true
         exit while
      endif
      i% = i% - 1
      if i% = 0 then
         exit while
      endif
   wend
   if found% = true then
      i% = i% + 1
      withoutpath$ = mid( spec$, i% )
      i% = i% - 1
      justPath$ = left( spec$, i% )
   else
      withoutpath$ = spec$
      justPath$ = ""
   endif

end sub




sub parsefil( fspec$ )
   c$ = mid( fspec$, 2, 1 )
   if c$ = ":" then
      PF_drv$ = left( fspec$, 1 )
   endif
   call nopath( fspec$ )
   PF_path$ = justPath$
   PF_nameExt$ = withoutpath$
   d% = cinstr( PF_nameExt$, 46 )
   if d% > 0 then
      d% = d% - 1
      PF_name$ = left( PF_nameExt$, d% )
      d% = d% + 1
      PF_ext$ = mid( PF_nameExt$, d% )
   else
      PF_name$ = PFnameExt$
      PF_ext$ = "."
   endif
end sub


